<template>
  <div class="pb-[80px] px-8">
    <div
      class="gameSection w-full grid xl:gap-y-10 xl:gap-x-10 gap-y-5 gap-x-5 grid-cols-[1fr_1fr_1fr]"
    >
      <div v-if="!topGame.IsHidden" class="statistic">
        <div class="statistic__count bg-default">
          <span>{{ popularGamesCount }}</span>
        </div>
        <div class="statistic__description">
          <h4>{{ topGame.Text }}</h4>
          <nuxt-link class="see-all-link" to="/games?t=TopGame"
            >{{ $t("see_all") }}
            <font-awesome-icon class="ml-4" icon="arrow-right" />
          </nuxt-link>
        </div>
      </div>
      <div v-if="!newGame.IsHidden" class="statistic">
        <div class="statistic__count bg-default">
          <span>{{ newGamesCount }}</span>
        </div>
        <div class="statistic__description">
          <h4>{{ newGame.Text }}</h4>
          <nuxt-link class="see-all-link" to="/games?t=NewGame"
            >{{ $t("see_all") }}
            <font-awesome-icon class="ml-4" icon="arrow-right" />
          </nuxt-link>
        </div>
      </div>
      <div v-if="!gameProvider.IsHidden" class="statistic">
        <div class="statistic__count bg-default">
          <span>{{ providersCount }}</span>
        </div>
        <div class="statistic__description">
          <h4>{{ gameProvider.Text }}</h4>
          <GameProviderCategory
            :is-game-page="true"
            :is-game-provider="true"
            :should-fix-z-index="true"
          />
        </div>
      </div>
    </div>
  </div>
</template>

<script lang="ts">
import { computed, defineComponent, PropType } from "vue";
import GameProviderCategory from "./GameProviderCategory.client.vue";
import { store } from "@/store";
import { IThemePropertiesFromApi } from "@/models/companyThemePropertiesRespone";
import themePropertyHelper from "@/utils/themePropertyHelper";
import { gameStore } from "~~/store/game";

export default defineComponent({
  components: { GameProviderCategory },
  props: {
    indexBlog: {
      type: Object as PropType<Array<IThemePropertiesFromApi>>,
      required: true,
    },
  },
  setup() {
    const themeProperties = computed(
      () => store.state.companyThemePropertiesFromApi.ThemeProperties
    );
    const topGame = computed(
      (): IThemePropertiesFromApi =>
        themePropertyHelper.getSingleThemeProperty(
          themeProperties.value,
          "index_blog_1"
        )
    );
    const newGame = computed(
      (): IThemePropertiesFromApi =>
        themePropertyHelper.getSingleThemeProperty(
          themeProperties.value,
          "index_blog_2"
        )
    );
    const gameProvider = computed(
      (): IThemePropertiesFromApi =>
        themePropertyHelper.getSingleThemeProperty(
          themeProperties.value,
          "index_blog_3"
        )
    );
    const popularGamesCount = computed(
      () =>
        gameStore.state.games.filter((game) => game.IsHotGame === true).length
    );
    const newGamesCount = computed(
      () =>
        gameStore.state.games.filter((game) => game.IsNewGame === true).length
    );
    const providersCount = computed(
      () => store.state.gameTabProviderList.SeamlessProviderList.length
    );
    return {
      topGame,
      newGame,
      gameProvider,
      popularGamesCount,
      newGamesCount,
      providersCount,
    };
  },
});
</script>

<style lang="scss" scoped>
@media (max-width: 640px) {
  .gameSection {
    grid-template-columns: 1fr;
    grid-gap: 16px;
  }
}
.statistic {
  display: flex;
  flex-direction: row;
  align-items: center;
  padding: 12px;
  box-shadow: var(--box-shadow-inset);
  border-radius: 16px;
  background: var(--button-bg);
  @media (max-width: 1220px) {
    flex-direction: column;
    align-items: flex-start;
  }
  @media (max-width: 640px) {
    flex-direction: row;
    align-items: center;
    padding: 8px;
  }
}
.statistic__count {
  text-align: center;
  font-size: 36px;
  line-height: 46px;
  margin: 0 20px 0 0;
  min-width: 92px;
  padding: 8px 16px;
  color: var(--textBtn);
  font-weight: bold;
  background: var(--primary);
  border-radius: 8px;
  margin-right: 20px;
  @media (max-width: 1220px) {
    width: 100%;
    margin: 0 0 16px 0;
    text-align: center;
    font-size: 24px;
    line-height: 32px;
  }
  @media (max-width: 640px) {
    width: 92px;
    margin: 0 20px 0 0;
  }
}
:deep(.statistic h4) {
  font-size: 24px;
  line-height: 32px;
  margin-bottom: 6px;
  font-weight: bold;
  transition: color 0.4s;
  color: var(--title-font-color);
}
:deep(.see-all-link) {
  align-items: center;
  font-weight: 600;
  font-size: 16px;
  line-height: 24px;
  text-transform: uppercase;
  text-decoration: none !important;
  display: flex;
  cursor: pointer;
}
</style>
